<?php

set_time_limit(25);

include("torrent_inc.php");

$torrentfile = $_GET["torrent"];

if ($torrentid = torrentExists($torrentfile)) {
	// Already exists, continue...
} else {
	// Add to DB if possible
	$torrentid = addNewTorrent($torrentfile);
	if ($torrentid == false) {
		//TODO: Show a default image
		exit();
	}
}	

$name = torrentName($torrentid);

$totalsize = torrentSize($torrentid);
$totalsize = $totalsize / 1048576;
if ($totalsize < 1) {
	$totalsize = "<1MB";
} else {
	$totalsize = intval($totalsize) . "MB";
}


header('Last-Modified: ' . date('D, d M Y H:i:s', time()) . ' GMT');
header('Expires: ' . date('D, d M Y H:i:s', time() + 2400) . ' GMT');

$stats = getTorrentStats($torrentid);
$numseeds = $stats[0];
$numleeches = $stats[1];
$lastupdated = $stats[2];


if (trim($numseeds) == "" || trim($numleeches) == "") {
	$statsText = "*DOWN*";
} else {
	$statsText = $numseeds . " seeds and " . $numleeches . " leeches";
}
$statsText .= " / " . $totalsize;


if(strlen($name) > strlen($statsText)) {
	$width = intval(strlen($name) * 6.27);
} else {
	$width = intval(strlen($statsText) * 6.27);
}

if($width < 85) {
	$width = 85;
}

$returnImage = imagecreatetruecolor($width, 40);


if($_GET["textcolor"] != "") {
	hextorgb($_GET["textcolor"]);
} else {
	$GLOBALS["red"] = 255;
	$GLOBALS["green"] = 255;
	$GLOBALS["blue"] = 255;
}

$textColor = imagecolorallocate($returnImage, $GLOBALS["red"], $GLOBALS["green"], $GLOBALS["blue"]);

if($_GET["bgcolor"] != "") {
        hextorgb($_GET["bgcolor"]);
} else {
        $GLOBALS["red"] = 0;
        $GLOBALS["green"] = 42;
        $GLOBALS["blue"] = 78;
}
imagefilledrectangle($returnImage, 0, 0, $width, 40, imagecolorallocate($returnImage, $GLOBALS["red"], $GLOBALS["green"], $GLOBALS["blue"]));

imagestring($returnImage, 2, 3, 1, $name, $textColor);

imagestring($returnImage, 2, 3, 16, $statsText, $textColor);

imagefilledrectangle($returnImage, 0, 30, $width, 40, imagecolorallocate($returnImage, 0, 42, 78));

$updatedminsago = intval((time() - $lastupdated) / 60);

if ($width > 330) {
        imagestring($returnImage, 1, 3, 31, "Live Stats @ " . $updatedminsago . " mins ago - Powered by MyScreenshot.com", imagecolorallocate($returnImage, 255, 255, 255));
} elseif ($width > 268) {
        imagestring($returnImage, 1, 3, 31, "Live Stats @ " . $updatedminsago . " mins ago - MyScreenshot.com", imagecolorallocate($returnImage, 255, 255, 255));
} elseif ($width > 155) {
	imagestring($returnImage, 1, 3, 31, "Live Stats by MyScreenshot.com", imagecolorallocate($returnImage, 255, 255, 255));
} else {
        imagestring($returnImage, 1, 3, 31, "MyScreenshot.com", imagecolorallocate($returnImage, 255, 255, 255));
}

imageinterlace($returnImage, 1);

if (strtoupper($_GET["format"]) == "GIF" && function_exists("imagegif")) {
	header("Content-type: image/gif");
        header("Content-Disposition: filename=torrentstats.gif");
	imagegif($returnImage); 
} elseif (strtoupper($_GET["format"]) == "PNG" && function_exists("imagepng")) {
        header("Content-type: image/png");
        header("Content-Disposition: filename=torrentstats.png");
	
        imagepng($returnImage);
} else {
	header("Content-type: image/jpeg");
	header("Content-Disposition: filename=torrentstats.jpg");
	imagejpeg($returnImage, "", 100);
}
imagedestroy($returnImage);

function hextorgb($hexcode){
    $hexcode = str_replace("#","",$hexcode);
    $GLOBALS["hexcode"] = str_replace("#","",$hexcode);
    $GLOBALS["red"] = hexdec(substr($hexcode, 0, 2));  
    $GLOBALS["green"] = hexdec(substr($hexcode, 2, 2));
    $GLOBALS["blue"] = hexdec(substr($hexcode, 4, 2));
} 

?>
